Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class TreeMultimap<K,V>

    java.lang.Object
      com.google.common.collect.TreeMultimap<K,V>

All Implemented Interfaces:
  Multimap<K,V>, SetMultimap<K,V>, SortedSetMultimap<K,V>, Serializable

    @GwtCompatible(serializable=true,
                   emulated=true)
    public class TreeMultimap<K,V>

extends Object

Implementation of `Multimap` whose keys and values are ordered by their natural ordering or by supplied comparators. In all cases, this implementation uses `Comparable.compareTo(T)` or `Comparator.compare(T, T)` instead of `Object.equals(java.lang.Object)` to determine equivalence of instances.

Warning: The comparators or comparables used must be consistent with equals as explained by the `Comparable` class specification. Otherwise, the resulting multiset will violate the general contract of `SetMultimap`, which it is specified in terms of `Object.equals(java.lang.Object)`.

The collections returned by `keySet` and `asMap` iterate through the keys according to the key comparator ordering or the natural ordering of the keys. Similarly, `get`, `removeAll`, and `replaceValues` return collections that iterate through the values according to the value comparator ordering or the natural ordering of the values. The collections generated by `entries`, `keys`, and `values` iterate across the keys according to the above key ordering, and for each key they iterate across the values according to the value ordering.

The multimap does not store duplicate key-value pairs. Adding a new key-value pair equal to an existing key-value pair has no effect.

Null keys and values are permitted (provided, of course, that the respective comparators support them). All optional multimap methods are supported, and all returned views are modifiable.

This class is not threadsafe when any concurrent operations update the multimap. Concurrent read operations will work correctly. To allow concurrent update operations, wrap your multimap with a call to `Multimaps.synchronizedSortedSetMultimap(com.google.common.collect.SortedSetMultimap)`.

Since:
  2.0 (imported from Google Collections Library)
Author:
  Jared Levy
See Also:
  Serialized Form

Method Summary
`SortedMap<K,Collection<V>>` | `asMap()` Returns a map view that associates each key with the corresponding values in the multimap.
`void` | `clear()` Removes all key-value pairs from the multimap.
`boolean` | `containsEntry(Object key, Object value)` Returns `true` if the multimap contains the specified key-value pair.
`boolean` | `containsKey(Object key)` Returns `true` if the multimap contains any values for the specified key.
`boolean` | `containsValue(Object value)` Returns `true` if the multimap contains the specified value for any key.
`static
`<K extends Comparable,V extends Comparable> TreeMultimap<K,V>`
` | `create()` Creates an empty `TreeMultimap` ordered by the natural ordering of its keys and values.
`static
`<K,V> TreeMultimap<K,V>`
` | `create(Comparator<? super K> keyComparator, Comparator<? super V> valueComparator)` Creates an empty `TreeMultimap` instance using explicit comparators.
`static
`<K extends Comparable,V extends Comparable> TreeMultimap<K,V>`
` | `create(Multimap<? extends K,? extends V> multimap)` Constructs a `TreeMultimap`, ordered by the natural ordering of its keys and values, with the same mappings as the specified multimap.
`Set<Map.Entry<K,V>>` | `entries()` Returns a collection of all key-value pairs.
`boolean` | `equals(Object object)` Compares the specified object to this multimap for equality.
`SortedSet<V>` | `get(K key)` Returns a collection view of all values associated with a key.
`int` | `hashCode()` Returns the hash code for this multimap.
`boolean` | `isEmpty()` Returns `true` if the multimap contains no key-value pairs.
`Comparator<? super K>` | `keyComparator()` Returns the comparator that orders the multimap keys.
`Multiset<K>` | `keys()` Returns a collection, which may contain duplicates, of all keys.
`SortedSet<K>` | `keySet()` Returns the set of all keys, each appearing once in the returned set.
`boolean` | `put(K key, V value)` Stores a key-value pair in the multimap.
`boolean` | `putAll(K key, Iterable<? extends V> values)` Stores a collection of values with the same key.
`boolean` | `putAll(Multimap<? extends K,? extends V> multimap)` Copies all of another multimap's key-value pairs into this multimap.
`boolean` | `remove(Object key, Object value)` Removes a key-value pair from the multimap.
`SortedSet<V>` | `removeAll(Object key)` Removes all values associated with a given key.
`SortedSet<V>` | `replaceValues(K key, Iterable<? extends V> values)` Stores a collection of values with the same key, replacing any existing values for that key.
`int` | `size()` Returns the number of key-value pairs in the multimap.
`String` | `toString()` Returns a string representation of the multimap, generated by calling `toString` on the map returned by `Multimap.asMap()`.
`Comparator<? super V>` | `valueComparator()` Returns the comparator that orders the multimap values, with `null` indicating that natural ordering is used.
`Collection<V>` | `values()` Returns a collection of all values in the multimap.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.google.common.collect.SetMultimap
`entries, equals`

Methods inherited from interface com.google.common.collect.Multimap
`clear, containsEntry, containsKey, containsValue, hashCode, isEmpty, keys, put, putAll, putAll, remove, size`

Method Detail

### create

    public static <K extends Comparable,V extends Comparable> TreeMultimap<K,V> create()

  Creates an empty `TreeMultimap` ordered by the natural ordering of its keys and values.

### create

    public static <K,V> TreeMultimap<K,V> create(Comparator<? super K> keyComparator,
                                                 Comparator<? super V> valueComparator)

  Creates an empty `TreeMultimap` instance using explicit comparators. Neither comparator may be null; use `Ordering.natural()` to specify natural order.

  Parameters:
    `keyComparator` - the comparator that determines the key ordering
    `valueComparator` - the comparator that determines the value ordering

### create

    public static <K extends Comparable,V extends Comparable> TreeMultimap<K,V> create(Multimap<? extends K,? extends V> multimap)

  Constructs a `TreeMultimap`, ordered by the natural ordering of its keys and values, with the same mappings as the specified multimap.

  Parameters:
    `multimap` - the multimap whose contents are copied to this multimap

### keyComparator

    public Comparator<? super K> keyComparator()

  Returns the comparator that orders the multimap keys.

### valueComparator

    public Comparator<? super V> valueComparator()

  Description copied from interface: `SortedSetMultimap`
  Returns the comparator that orders the multimap values, with `null` indicating that natural ordering is used.

### keySet

    public SortedSet<K> keySet()

  Returns the set of all keys, each appearing once in the returned set. Changes to the returned set will update the underlying multimap, and vice versa.

  Because a `TreeMultimap` has unique sorted keys, this method returns a `SortedSet`, instead of the `Set` specified in the `Multimap` interface.

  Specified by:
    `keySet` in interface `Multimap<K,V>`
  Returns:
    the collection of distinct keys

### asMap

    public SortedMap<K,Collection<V>> asMap()

  Returns a map view that associates each key with the corresponding values in the multimap. Changes to the returned map, such as element removal, will update the underlying multimap. The map does not support `setValue` on its entries, `put`, or `putAll`.

  When passed a key that is present in the map, `asMap().get(Object)` has the same behavior as `get(K)`, returning a live collection. When passed a key that is not present, however, `asMap().get(Object)` returns `null` instead of an empty collection.

  Though the method signature doesn't say so explicitly, the returned map has `SortedSet` values.

  Because a `TreeMultimap` has unique sorted keys, this method returns a `SortedMap`, instead of the `Map` specified in the `Multimap` interface.

  Specified by:
    `asMap` in interface `Multimap<K,V>`
  Specified by:
    `asMap` in interface `SetMultimap<K,V>`
  Specified by:
    `asMap` in interface `SortedSetMultimap<K,V>`
  Returns:
    a map view from a key to its collection of values

### get

    public SortedSet<V> get(@Nullable
                            K key)

  Returns a collection view of all values associated with a key. If no mappings in the multimap have the provided key, an empty collection is returned.

  Changes to the returned collection will update the underlying multimap, and vice versa.

  Because a `SortedSetMultimap` has unique sorted values for a given key, this method returns a `SortedSet`, instead of the `Collection` specified in the `Multimap` interface.

  Specified by:
    `get` in interface `Multimap<K,V>`
  Specified by:
    `get` in interface `SetMultimap<K,V>`
  Specified by:
    `get` in interface `SortedSetMultimap<K,V>`
  Parameters:
    `key` - key to search for in multimap
  Returns:
    the collection of values that the key maps to

### removeAll

    public SortedSet<V> removeAll(@Nullable
                                  Object key)

  Removes all values associated with a given key. The returned collection is immutable.

  Because a `SortedSetMultimap` has unique sorted values for a given key, this method returns a `SortedSet`, instead of the `Collection` specified in the `Multimap` interface.

  Specified by:
    `removeAll` in interface `Multimap<K,V>`
  Specified by:
    `removeAll` in interface `SetMultimap<K,V>`
  Specified by:
    `removeAll` in interface `SortedSetMultimap<K,V>`
  Parameters:
    `key` - key of entries to remove from the multimap
  Returns:
    the collection of removed values, or an empty collection if no values were associated with the provided key. The collection may be modifiable, but updating it will have no effect on the multimap.

### replaceValues

    public SortedSet<V> replaceValues(K key,
                                      Iterable<? extends V> values)

  Stores a collection of values with the same key, replacing any existing values for that key. The returned collection is immutable.

  Because a `SortedSetMultimap` has unique sorted values for a given key, this method returns a `SortedSet`, instead of the `Collection` specified in the `Multimap` interface.

  Any duplicates in `values` will be stored in the multimap once.

  Specified by:
    `replaceValues` in interface `Multimap<K,V>`
  Specified by:
    `replaceValues` in interface `SetMultimap<K,V>`
  Specified by:
    `replaceValues` in interface `SortedSetMultimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `values` - values to store in the multimap
  Returns:
    the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.

### values

    public Collection<V> values()

  Returns a collection of all values in the multimap. Changes to the returned collection will update the underlying multimap, and vice versa.

  The iterator generated by the returned collection traverses the values for one key, followed by the values of a second key, and so on. Consequently, the values do not follow their natural ordering or the ordering of the value comparator.

  Specified by:
    `values` in interface `Multimap<K,V>`
  Returns:
    collection of values, which may include the same value multiple times if it occurs in multiple mappings

### entries

    public Set<Map.Entry<K,V>> entries()

  Returns a collection of all key-value pairs. Changes to the returned collection will update the underlying multimap, and vice versa. The entries collection does not support the `add` or `addAll` operations.

  The iterator generated by the returned collection traverses the values for one key, followed by the values of a second key, and so on.

  Each entry is an immutable snapshot of a key-value mapping in the multimap, taken at the time the entry is returned by a method call to the collection or its iterator.

  Because a `SetMultimap` has unique values for a given key, this method returns a `Set`, instead of the `Collection` specified in the `Multimap` interface.

  Specified by:
    `entries` in interface `Multimap<K,V>`
  Specified by:
    `entries` in interface `SetMultimap<K,V>`
  Returns:
    collection of map entries consisting of key-value pairs

### put

    public boolean put(K key,
                       V value)

  Stores a key-value pair in the multimap.

  Specified by:
    `put` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `value` - value to store in the multimap
  Returns:
    `true` if the method increased the size of the multimap, or `false` if the multimap already contained the key-value pair

### equals

    public boolean equals(@Nullable
                          Object object)

  Compares the specified object to this multimap for equality.

  Two `SetMultimap` instances are equal if, for each key, they contain the same values. Equality does not depend on the ordering of keys or values.

  Specified by:
    `equals` in interface `Multimap<K,V>`
  Specified by:
    `equals` in interface `SetMultimap<K,V>`

### size

    public int size()

  Description copied from interface: `Multimap`
  Returns the number of key-value pairs in the multimap.

  Specified by:
    `size` in interface `Multimap<K,V>`

### isEmpty

    public boolean isEmpty()

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains no key-value pairs.

  Specified by:
    `isEmpty` in interface `Multimap<K,V>`

### containsKey

    public boolean containsKey(@Nullable
                               Object key)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains any values for the specified key.

  Specified by:
    `containsKey` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap

### containsValue

    public boolean containsValue(@Nullable
                                 Object value)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains the specified value for any key.

  Specified by:
    `containsValue` in interface `Multimap<K,V>`
  Parameters:
    `value` - value to search for in multimap

### containsEntry

    public boolean containsEntry(@Nullable
                                 Object key,
                                 @Nullable
                                 Object value)

  Description copied from interface: `Multimap`
  Returns `true` if the multimap contains the specified key-value pair.

  Specified by:
    `containsEntry` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to search for in multimap
    `value` - value to search for in multimap

### remove

    public boolean remove(@Nullable
                          Object key,
                          @Nullable
                          Object value)

  Description copied from interface: `Multimap`
  Removes a key-value pair from the multimap.

  Specified by:
    `remove` in interface `Multimap<K,V>`
  Parameters:
    `key` - key of entry to remove from the multimap
    `value` - value of entry to remove the multimap
  Returns:
    `true` if the multimap changed

### putAll

    public boolean putAll(@Nullable
                          K key,
                          Iterable<? extends V> values)

  Description copied from interface: `Multimap`
  Stores a collection of values with the same key.

  Specified by:
    `putAll` in interface `Multimap<K,V>`
  Parameters:
    `key` - key to store in the multimap
    `values` - values to store in the multimap
  Returns:
    `true` if the multimap changed

### putAll

    public boolean putAll(Multimap<? extends K,? extends V> multimap)

  Description copied from interface: `Multimap`
  Copies all of another multimap's key-value pairs into this multimap. The order in which the mappings are added is determined by `multimap.entries()`.

  Specified by:
    `putAll` in interface `Multimap<K,V>`
  Parameters:
    `multimap` - mappings to store in this multimap
  Returns:
    `true` if the multimap changed

### clear

    public void clear()

  Description copied from interface: `Multimap`
  Removes all key-value pairs from the multimap.

  Specified by:
    `clear` in interface `Multimap<K,V>`

### keys

    public Multiset<K> keys()

  Description copied from interface: `Multimap`
  Returns a collection, which may contain duplicates, of all keys. The number of times of key appears in the returned multiset equals the number of mappings the key has in the multimap. Changes to the returned multiset will update the underlying multimap, and vice versa.

  Specified by:
    `keys` in interface `Multimap<K,V>`
  Returns:
    a multiset with keys corresponding to the distinct keys of the multimap and frequencies corresponding to the number of values that each key maps to

### hashCode

    public int hashCode()

  Returns the hash code for this multimap.

  The hash code of a multimap is defined as the hash code of the map view, as returned by `Multimap.asMap()`.

  Specified by:
    `hashCode` in interface `Multimap<K,V>`
  Overrides:
    `hashCode` in class `Object`
  See Also:
    `Map.hashCode()`

### toString

    public String toString()

  Returns a string representation of the multimap, generated by calling `toString` on the map returned by `Multimap.asMap()`.

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of the multimap

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2011. All Rights Reserved.